import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class Task3m {

	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		StringTokenizer st = new StringTokenizer(br.readLine());
		int n = Integer.parseInt(st.nextToken());
		int m = Integer.parseInt(st.nextToken());
		st = new StringTokenizer(br.readLine());
		int[] a = new int[m];
		for (int i = 0; i < m; i++) {
			a[i] = Integer.parseInt(st.nextToken()) - 1;
		}
		st = new StringTokenizer(br.readLine());
		ArrayList<Integer> b = new ArrayList<Integer>();
		for (int i = 0; i < n; i++) {
			b.add(Integer.parseInt(st.nextToken()) - 1);
		}
		br.close();

		// -----
		int[][] nextmeet = new int[m][n];
		for (int i = 0; i < n; i++) {
			nextmeet[m - 1][i] = -1;
		}
		for (int j = m - 2; j >= 0; j--) {
			for (int i = 0; i < n; i++) {
				if (a[j + 1] == i) {
					nextmeet[j][i] = j + 1;
				} else {
					nextmeet[j][i] = nextmeet[j + 1][i];
				}
			}
		}

		int[] bindexes = new int[n];
		for (int i = 0; i < n; i++) {
			bindexes[b.get(i)] = i;
		}

		ArrayList<Integer> actions = new ArrayList<Integer>();
		for (int j = 0; j < m - 1; j++) {
			boolean topok = false;

			do {
				if (a[j] == b.get(0))
					topok = true;
				int cur = b.get(0);

				if (nextmeet[j][cur] == -1) {
					b = insert(b, n - 1, cur);

					for (int i = 1; i <= n - 1; i++) {
						bindexes[b.get(i)]--;
					}
					bindexes[b.get(0)] = n - 1;

					actions.add(n - 1 + 1);
					b.remove(0);
					continue;
				}
				int upmost = bindexes[a[j]];
				for (int i = j; i < nextmeet[j][cur]; i++) {
					upmost = Math.max(upmost, bindexes[i]);
				}
				b = insert(b, upmost, cur);

				for (int i = 1; i <= upmost; i++) {
					bindexes[b.get(i)]--;
				}
				bindexes[b.get(0)] = upmost;

				actions.add(upmost + 1);
				b.remove(0);

			} while (!topok);
		}

		// now last j
		actions.add(1);

		System.out.println(actions.size());
		for (Integer i : actions) {
			System.out.print(i + " ");
		}
		System.out.println();

	}

	public static ArrayList<Integer> insert(ArrayList<Integer> list, int insertAfterIndex, int toInsert) {
		int iai = insertAfterIndex;
		ArrayList<Integer> l1 = new ArrayList<Integer>(list.subList(0, iai + 1));
		l1.add(toInsert);
		l1.addAll(list.subList(iai + 1, list.size()));
		return l1;
	}

}
